import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.*;
import java.net.*;
import java.sql.*;
import java.util.*;
import javax.swing.*;
import com.sun.image.codec.jpeg.*;

/**
Show JPG File(s)
*/
public class ShowJPG extends JFrame {

  /**
  Image Panel
  */
  private ImPanel imP;

  /**
  Desktop
  */
  private JDesktopPane desktop;

  /**
  Copyright
  */
  private String copyr = new String("Copyright 2000 Mike Calder-Smith");

  /**
  Application Name
  */
  private String appname = new String("ShowJPG ");

  /**
  Current Directory
  */
  private String currDir;

  /**
  Image 1
  */
  BufferedImage im1;

  /**
  Image 2
  */
  BufferedImage im2;

  /**
  Image Area Width
  */
  int width;

  /**
  Image Area Height
  */
  int height;

  private final class ImPanel extends JPanel {

    /**
    Parent
    */
    ShowJPG upThere;

    public ImPanel( ShowJPG parent) {
      upThere = parent;
    }

    public void paint( Graphics g ) {
      Graphics2D g2D = (Graphics2D)g;
      super.paint(g2D);

      g2D.setBackground( Color.black );
      g2D.clearRect( 0, 0, width, height );

      if (upThere.im1 != null) {
        g2D.drawImage( upThere.im1, 0, 0, null);
      }

      if (upThere.im2 != null) {
        g2D.setXORMode( Color.black );
        g2D.drawImage( upThere.im2, 0, 0, null);
      }
    }

  }

  /**
  Mainline
  */
  public static void main(String args[]) {
    String a1 = new String ("");
    String a2 = new String ("");

    for (int i=0;i<args.length;i++) {
      if (i==0) a1 = args[0];
      if (i==1) a2 = args[1];
    }

    if (a1 != null) {
      ShowJPG app = new ShowJPG( a1, a2 );
      app.show  ();
    }

  }

  public ShowJPG(String f1, String f2) {

    super();
    setTitle(appname + copyr);

    Dimension screenSize;

    Toolkit tk = Toolkit.getDefaultToolkit();
    screenSize = tk.getScreenSize();

    width = 250;
    height = 250;
    try {
      File f = new File( f1 );
      FileInputStream fin = new FileInputStream( f );
      JPEGImageDecoder jimi = JPEGCodec.createJPEGDecoder( fin );
      im1 = jimi.decodeAsBufferedImage();
      if (im1 == null) {
        System.out.println( "No image found in file " + f1);
      } else {
        width = im1.getWidth(null);
        height = im1.getHeight(null);
        setTitle(appname + " " + f1 + " " + copyr);
        if (width > 0) {
          if (height > 0) {
            setSize( width, height);
          } else {
            System.out.println( "Image from file " + f1 + "has zero width ");
          }
        } else {
          System.out.println( "Image from file " + f1 + "has zero width ");
        }
      }
    } catch(Exception e) {
      System.out.println( "failed to read image from file " + f1 + " exception " + e );
    }

    if (f1.length() != 0) {
      try {
        File f = new File( f2 );
        FileInputStream fin = new FileInputStream( f );
        JPEGImageDecoder jimi = JPEGCodec.createJPEGDecoder( fin );
        im2 = jimi.decodeAsBufferedImage();
        if (im2 == null) {
          System.out.println( "No image found in file " + f2);
        } else {
          setTitle(appname + " " + f1 + " against " + f2 + " " + copyr);
        }
      } catch(Exception e) {
        System.out.println( "failed to read image from file " + f2 + " exception " + e );
      }
    }

    width = width + 10;
    height = height + 30;

    if (width > screenSize.width) width = screenSize.width;
    if (height > screenSize.height) height = screenSize.height;

    setSize( width, height);


    desktop = new JDesktopPane();
    getContentPane().add(desktop);
    imP = new ImPanel(this);
    imP.setBounds ( 0, 0, width, height);
    desktop.add( imP );

    imP.repaint();


    addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent event) {
            dispose();
            System.exit(0);
        }
    });

  }

}


